<template>
  <v-switch
    v-model="model"
    @update:model-value="update"
    :disabled="disabled"
    :density="density"
    base-color="borderColor"
    :false-icon="icon ? 'mdi-close' : undefined"
    :true-icon="icon ? 'mdi-check' : undefined"
    :color="color"
    :readonly="readonly"
    inset
    hide-details
    :id="switchId"
  >
  </v-switch>
</template>

<script setup>
import { ref, watch, onMounted } from "vue";

const emit = defineEmits(['update:modelValue']);

onMounted(() => {
  model.value = props?.modelValue;
});

const model = ref(null);

const props = defineProps({
  modelValue: {
    type: undefined,
    default: false,
  },
  density: {
    type: String,
    default: "compact",
  },
  readonly: {
    type: Boolean,
    default: false,
  },
  disabled: {
    type: Boolean,
    default: false,
  },
  color: {
    type: String,
    default: 'primary',
  },
  icon: {
    type: Boolean,
    default: false,
  },
  switchId: {
    type: String,
    default: null
  },
})

const update = (value) => {
  emit('update:modelValue', value);
}

watch(props, (newValue, oldValue) => {
  if (newValue?.modelValue) {
    model.value = newValue?.modelValue;
  }
})
</script>

<style scoped>
* :deep(.v-switch__track) {
  opacity: 1 !important;
}
</style>
